QGIS Application - Bug report #21517
Estimated Extent fails when rows exceed 32-bit signed integer max, issues slow ST_Extent query
2019-03-07 11:04 PM - Jesse Ogle

Status: Closed

Priority: Normal

Assignee:

Category: Data Provider/PostGIS

Affected QGIS version:3.7(master) Regression?: No
Operating System: Windows, Linux Easy fix?: Yes
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 29334
Description

When 'Use estimated table meta data' is selected in the PostGIS Connection dialog, QGis will still use ST_Extent() instead of
ST_EstimatedExtent() if the table has more than int max rows. The ST_Extent() query is prohibitively slow and causes QGis to hang.

This appears to be the result of casting reltuples to int in the SQL query in this line:
https://github.com/qgis/QGIS/blob/2403c64a7c26f1646fcba6142265¢7c953540f28/src/providers/postgres/qgspostgresprovider.cpp#L
252

This results in an error which causes the extent to be cleared and then ST_Extent() is used. Changing ::int to ::bigint resolves this issue
(verified via psqgl query not through QGis).

The following line will also fail when reltuples is greater than int max:
https://github.com/qgis/QGIS/blob/2403c64a7c26f1646fcbab142265¢7c953540f28/src/providers/postgres/qgspostgresprovider.cpp#l
193

Data source: PostgreSQL 10.5, compiled by Visual C++ build 1800, 64-bit

Associated revisions

Revision feb0c8bd - 2019-03-08 02:19 AM - Nyall Dawson

[postgres] Fix estimated metadata queries fail for huge tables

Fixes #21517

Revision d15d1242 - 2019-03-08 02:19 AM - Nyall Dawson

[postgres] Fix estimated metadata queries fail for huge tables

Fixes #21517

Revision ¢1089238 - 2019-03-08 02:19 AM - Nyall Dawson

[postgres] Fix estimated metadata queries fail for huge tables

Fixes #21517

2025-05-18 12



https://github.com/qgis/QGIS/blob/2403c64a7c26f1646fcba6142265c7c953540f28/src/providers/postgres/qgspostgresprovider.cpp#L3252
https://github.com/qgis/QGIS/blob/2403c64a7c26f1646fcba6142265c7c953540f28/src/providers/postgres/qgspostgresprovider.cpp#L3252
https://github.com/qgis/QGIS/blob/2403c64a7c26f1646fcba6142265c7c953540f28/src/providers/postgres/qgspostgresprovider.cpp#L3193
https://github.com/qgis/QGIS/blob/2403c64a7c26f1646fcba6142265c7c953540f28/src/providers/postgres/qgspostgresprovider.cpp#L3193

Revision dcc9f11c - 2019-03-10 10:46 PM - Nyall Dawson

[postgres] Fix estimated metadata queries fail for huge tables

Fixes #21517

Revision da2064d0 - 2019-03-10 11:59 PM - Nyall Dawson

[postgres] Fix estimated metadata queries fail for huge tables

Fixes #21517

Revision aba1e308 - 2019-03-14 02:56 AM - Nyall Dawson

[postgres] Fix estimated metadata queries fail for huge tables

Fixes #21517

History

#1 - 2019-03-08 02:20 AM - Nyall Dawson
- Status changed from Open to In Progress

#2 - 2019-03-10 10:46 PM - Nyall Dawson
- % Done changed from 0 to 100
- Status changed from In Progress to Closed

Applied in changeset commit:qgis|dcc9f11c868390240dfa9b20ea837f1cbebdfads.
